/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in 
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2007.  All Rights Reserved.
 *
 * Protege was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu.
 *
 */


package edu.stanford.smi.protegex.owl.swrl.bridge.impl;

import edu.stanford.smi.protegex.owl.swrl.bridge.*;

public abstract class OWLPropertyAssertionAxiomImpl implements OWLPropertyAssertionAxiom 
{
  private OWLIndividual subject;
  private OWLProperty property;

  public OWLPropertyAssertionAxiomImpl(OWLIndividual subject, OWLProperty property)
  {
    this.subject = subject;
    this.property = property;
  } // OWLPropertyAssertionAxiomImpl

  public OWLIndividual getSubject() { return subject; }
  public OWLProperty getProperty() { return property; }

  public boolean equals(Object obj)
  {
    if (this == obj) return true;
    if ((obj == null) || (obj.getClass() != this.getClass())) return false;
    OWLPropertyAssertionAxiomImpl impl = (OWLPropertyAssertionAxiomImpl)obj;
    return ((subject != null && impl.subject != null && subject.equals(impl.subject)) &&
            (property != null && impl.property != null && property.equals(impl.property)));
  } // equals

  public int hashCode()
  {
    int hash = 45;
    hash = hash + (null == subject ? 0 : subject.hashCode());
    hash = hash + (null == property ? 0 : property.hashCode());
    return hash;
  } // hashCode

} // OWLPropertyAssertionAxiomImpl
